﻿define("epi-cms/component/SharedBlocksViewModel", [
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
// epi
    "../asset/view-model/HierarchicalListViewModel",

// command
    "./command/NewBlock",
    "epi-cms/command/ShowAllLanguages"
],

function (
// dojo
    declare,
    lang,
// epi
    HierarchicalListViewModel,

// command
    NewBlockCommand,
    ShowAllLanguagesCommand
) {

    return declare([HierarchicalListViewModel], {
        // summary:
        //      Handles search and tree to list browsing widgets.
        // tags:
        //      internal

        _selectedTreeItemsSetter: function (selectedItems) {
            // summary:
            //      Update model of commands in case selected content is folder
            // tags:
            //      private

            //The default upload command should only update when the list is updated.
            //It needs to be updated before the pseudocommanddecorator is applied.
            this._commandRegistry.newBlockDefault.command.set("model", selectedItems);

            this.inherited(arguments);
        },

        _setupCommands: function () {
            // summary:
            //      Creates and registers the commands used.
            // tags:
            //      protected

            this.inherited(arguments);

            var customCommands = {
                newBlockDefault: {
                    command: new NewBlockCommand({
                        viewModel: this
                    })
                },
                allLanguages: {
                    command: new ShowAllLanguagesCommand({ model: this }),
                    order: 55
                }
            };

            this._commandRegistry = lang.mixin(this._commandRegistry, customCommands);

            this.pseudoContextualCommands.push(this._commandRegistry.newBlockDefault.command);
        }
    });
});
